<?php
/*
*
* Sahana HTML form library
*
* PHP version 4 and 5
*
* LICENSE: This source file is subject to LGPL license
* that is available through the world-wide-web at the following URI:
* http://www.gnu.org/copyleft/lesser.html
*
* @package    Sahana - http://sahana.sourceforge.net
* @author     http://www.linux.lk/~chamindra
* @copyright  Lanka Software Foundation - http://www.opensource.lk
*
*/

// function to deal with additional options such as <BR> and is required 
function shn_form_extra_opts($extra_opts)
{
    // output a required flag
    if (true == $extra_opts['req']) echo "\n    <b>*(req)</b>\n"; 
    // output a break - default is true
    if (!isset($extra_opts['br']) || $extra_opts['br'] == true) echo "\n    <br />\n";
    
    
    }
// Open and close a form section

function shn_form_fopen($act, $mod = null, $form_opts =
array('req_message'=>true))
{
    global $global;
    if ( null == $mod ) $mod = $global['module'];

    if($form_opts['req_message']){
?>
    <p><b>Key:</b> Fields marked with <b>*</b> are required (entry is compulsory)</p>
<?php
    }
?>
    <div id="formcontainer">
    <form method="POST" action="index.php?mod=<?=$mod?>&act=<?=$act?>" id="formset" <?=$form_opts['enctype']?>name="<?=$form_opts['name']?>">
<?php
}

function shn_form_fclose()
{ ?>
    </form>
    </div> <!-- /formcontainer -->
<?php
}

function shn_form_submit($name)
{ ?>
    <input type="submit" value="<?=$name?>"/>
<?php
}

// Open and close a fieldset, which is a group of fields

function shn_form_fsopen($label = null)
{ ?>
    <fieldset>
    <legend><?=$label?></legend>
<?php
}

function shn_form_fsclose()
{ ?>
    </fieldset>
<?php
}

// enter the fields

function shn_form_button($name, $button_opts = null)
                        
{
?>
    <input type="button" value="<?=$name?>" <?=$button_opts?> />
<?php
}

function shn_form_text($label, $name, $text_opts = null, 
                        $extra_opts = null )
{
    $value = ($_POST[$name])? $_POST[$name] : $extra_opts['value'];
    if(get_magic_quotes_gpc())
        $value = stripslashes($value);
?>
    <label><?=$label?></label>
    <input type="text" name="<?=$name?>" value="<?=$value?>" <?=$text_opts?> />
<?php
    shn_form_extra_opts($extra_opts);
}

function shn_form_hidden($hidden_vars) 
{
    foreach ($hidden_vars as $name => $value) {
?>
    <input type="hidden" name="<?=$name?>" value="<?=$value?>">
<?php   
    }
}

function shn_form_checkbox($label, $name, $text_opts = null, 
                        $extra_opts = null)
{
    $value = ($_POST[$name])? $_POST[$name] : $extra_opts['value'];
?>
    <label><?=$label?></label>
    <input type="checkbox" name="<?=$name?>" value="<?=$value?>" <?=$text_opts?>  />
<?php
    shn_form_extra_opts($extra_opts);
}


function shn_form_select($options,$label, $name,$select_opts = "", $extra_opts = null)
{
    global $global;

    $value = ($_POST[$opt_field])? $_POST[$opt_field] : $extra_opts['value'];
?>
    <label><?=$label?></label>
    <select name="<?=$name?>" <?=$select_opts?> >
<?php
    foreach ($options as $opt_value => $desc ) {
    
        $sel = ( $res->fields[1] == $value ) ? "selected" : null ;
?>
        <option value="<?=$opt_value?>" <?=$sel?>><?=$desc?></option>
<?php
    }
?>
    </select> 
<?php
    shn_form_extra_opts($extra_opts);
} 

function shn_form_radio($options,$label, $name,$select_opts = "", $extra_opts = null)
{
    global $global;

    $value = ($_POST[$opt_field])? $_POST[$opt_field] : $extra_opts['value'];
?>
    <label><?=$label?></label>
<?php
    foreach ($options as $opt_value => $desc ) {
    
#        $sel = ( $res->fields[1] == $value ) ? "selected" : null ;
?>
        <input type="radio" name="<?=$name?>" value="<?=$opt_value?>"
<?=$sel?> /><?=$desc?>
<?php
    }
?>
<?php
    shn_form_extra_opts($extra_opts);
} 


// create a select field based on field options
function shn_form_opt_select($opt_field, $label, 
                                $select_opts = "", $extra_opts = null)
{
    global $global;

    $value = ($_POST[$opt_field])? $_POST[$opt_field] : $extra_opts['value'];
?>
    <label><?=$label?></label>
    <select name="<?=$opt_field?>" <?=$select_opts?> 
<?php
		    $res = $global['db']->Execute
        ("select * from field_options where field_name='$opt_field'");
    while(!res==NULL && !$res->EOF) {
        
        $sel = ( $res->fields[1] == $value ) ? "selected" : null ;
?>
 <option value="<?=$res->fields[1]?>" <?=$sel?>><?=$res->fields[2]?></option>
<?php	
		  
        $res->MoveNext();
      }
      if (isset($extra_opts['all']) || $extra_opts['all'] == true) echo "<option value='all'>All</option>";
 ?>
    </select> 
<?php
    shn_form_extra_opts($extra_opts);
} 

// create a select field based on field options
function shn_form_opt_multi_select($opt_field, $label, 
                                $select_opts = "", $extra_opts = null)
{
    global $global;

    $value = ($_POST[$opt_field])? $_POST[$opt_field] : $extra_opts['value'];
?>
    <label><?=$label?></label>
    <select name="<?=$opt_field?>[]" <?=$select_opts?> 
<?php
		    $res = $global['db']->Execute
        ("select * from field_options where field_name='$opt_field'");
    while(!res==NULL && !$res->EOF) {
        if($value!=NULL){ 
            $sel = ( (array_search($res->fields[1],$value)==true) || (array_search($res->fields[1],$value)===0) ) ? "selected" : null ;
        }
?>
 <option value="<?=$res->fields[1]?>" <?=$sel?>><?=$res->fields[2]?></option>
<?php	
		  
        $res->MoveNext();
      }
      if (isset($extra_opts['all']) || $extra_opts['all'] == true) echo "<option value='all'>All</option>";
 ?>
    </select> 
<?php
    shn_form_extra_opts($extra_opts);
} 

function shn_form_opt_checkbox($opt_field){
    global $global;
		$value = ($_POST[$opt_field])? $_POST[$opt_field] : null;
		$resu = $global['db']->Execute
		       ("select * from field_options where field_name='$opt_field'");
			     while(!resu==NULL && !$resu->EOF) {
		            $sel = ( $resu->fields[1] == $value ) ? "checked" : null ;
?>
				       <label><?=$resu->fields[2]?></label>
				       <input type="checkbox" name="<?=$opt_field?>[]" value="<?=$resu->fields[1]?>" <?=$sel?>></input>
     		       <br>
<?php
				       $resu->MoveNext();
   		     }
}

function shn_form_textarea($label, $name, $text_opts = null, 
                        $extra_opts = null)
{
    $value = ($_POST[$name])? $_POST[$name] : $extra_opts['value'];
    if(get_magic_quotes_gpc())
        $value = stripslashes($value);

?>
    <label><?=$label?></label>
    <textarea name="<?=$name?>" <?=$text_opts?> ><?=$value?></textarea>
<?php
    shn_form_extra_opts($extra_opts);
}

function shn_form_upload($label, $name,
                        $extra_opts = null)
{
?>
    <label><?=$label?></label>
    <input type="file" name="<?=$name?>" />
<?php
    shn_form_extra_opts($extra_opts);
}

function shn_form_label($label, $caption,
                        $extra_opts = null)
{
    if(get_magic_quotes_gpc())
        $caption = stripslashes($caption);
?>
    <label><?=$label?></label>
    <?=$caption?>
<?php
    shn_form_extra_opts($extra_opts);
}

function shn_form_password($label, $name, $text_opts = null, 
                        $extra_opts = null)
{
    $value = ($_POST[$name])? $_POST[$name] : $extra_opts['value'];
?>
    <label><?=$label?></label>
    <input type="password" name="<?=$name?>" value="<?=$value?>" <?=$text_opts?> />
<?php
    shn_form_extra_opts($extra_opts);
}

function shn_form_date($label, $name = 'date', $initdate = null ) 
{
    ($valueM = $_POST[$name.'M']) || ($valueM = ($initdate)? date('m',$initdate) : null);
    ($valueY = $_POST[$name.'Y']) || ($valueY = ($initdate)? date('Y',$initdate) : null);
    ($valueD = $_POST[$name.'D']) || ($valueD = ($initdate)? date('d',$initdate) : null);
    global $global;
?>
    <label><?=$label?></label>
    <p><?=_('Day')?></p>
    <input type="text" name="<?=$name.'D'?>" value="<?=$valueD?>" size="2">
    <?=_('Month')?>
    <input type="text" name="<?=$name.'M'?>" value="<?=$valueM?>" size="2">
    <?=_('Year')?>
    <input type="text" name="<?=$name.'Y'?>" value="<?=$valueY?>" size="4">
<?php
}

/* fancy popup calendar, however such systems are eyecandy and not efficient
function shn_form_date($label, $name = 'date') 
{
    #$today = date("Y-m-d");
    $today = date("d/m/Y");
    $value = ($_POST[$name])? $_POST[$name] : $extra_opts['value'];
    global $global;
?>
    <script language="javascript" type="text/javascript" src="res/js/calendar.core.js"></script>
    <label><?=$label?></label>
<?php
    require_once $global['approot']."/3rd/popupcal/cal_class.php";
    $calendario=new Calendar("en");
    $calendario->CreateCalendar($today,$name,"1/1/2000","12/30/2000");
    # @TODO handle localization and remove fixed date range above

    shn_form_extra_opts($extra_opts);
}
*/
?>
